<!-- 资金账户下拉列表 -->
<template>
    <app-remote-select v-model="selectedValue" :options="dataList"
        :option-props="{ label: 'relatedname', value: 'accountid' }" :remote-method="remoteMethod" @change="onChange"
        @reset="onReset">
        <template #default="{ option }">
            <div style="display: flex;justify-content: space-between;">
                <span>{{ option.accountid }}</span>
                <span>{{ option.relatedname }}</span>
            </div>
        </template>
    </app-remote-select>
</template>

<script lang="ts" setup>
import { computed, toRaw } from 'vue'
import { useRequest } from '@/hooks/request'
import { queryTAAccountChildrenSelect } from '@/services/api/report'
import AppRemoteSelect from '@pc/components/base/remote-select/index.vue'

const props = defineProps({
    modelValue: [Number, String]
})

const emit = defineEmits(['update:modelValue', 'change'])

const selectedValue = computed({
    get: () => props.modelValue,
    set: (val) => emit('update:modelValue', val)
})

const { dataList, loading, run } = useRequest(queryTAAccountChildrenSelect, {
    manual: true,
    onSuccess: (res) => {
        if (!res.data.some((e) => e.accountid.toString() === selectedValue.value?.toString())) {
            selectedValue.value = undefined
            onChange()
        }
    }
})

const onReset = () => {
    if (!loading.value) {
        run()
    }
}

const remoteMethod = (query: string) => {
    if (!loading.value) {
        if (query) {
            run({
                searchcode: query
            })
        } else if (!dataList.value.length) {
            onReset()
        }
    }
}

const onChange = (value?: number) => {
    const item = dataList.value.find((e) => e.accountid === value)
    emit('change', item && toRaw(item))
}

defineExpose({
    onReset
})
</script>